// SampleDisplay.h : Declaration of the CSampleDisplay

#ifndef __SAMPLEDISPLAY_H_
#define __SAMPLEDISPLAY_H_

#include "resource.h"       // main symbols
#include <atlctl.h>


/////////////////////////////////////////////////////////////////////////////
// CSampleDisplay
class ATL_NO_VTABLE CSampleDisplay : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CStockPropImpl<CSampleDisplay, ISampleDisplay, &IID_ISampleDisplay, &LIBID_SAMPLEAXCONTROLVCLib>,
	public CComControl<CSampleDisplay>,
	public IPersistStreamInitImpl<CSampleDisplay>,
	public IOleControlImpl<CSampleDisplay>,
	public IOleObjectImpl<CSampleDisplay>,
	public IOleInPlaceActiveObjectImpl<CSampleDisplay>,
	public IViewObjectExImpl<CSampleDisplay>,
	public IOleInPlaceObjectWindowlessImpl<CSampleDisplay>,
	public IPersistStorageImpl<CSampleDisplay>,
	public ISpecifyPropertyPagesImpl<CSampleDisplay>,
	public IQuickActivateImpl<CSampleDisplay>,
	public IDataObjectImpl<CSampleDisplay>,
	public IProvideClassInfo2Impl<&CLSID_SampleDisplay, NULL, &LIBID_SAMPLEAXCONTROLVCLib>,
	public CComCoClass<CSampleDisplay, &CLSID_SampleDisplay>
{
public:
	CSampleDisplay()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SAMPLEDISPLAY)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSampleDisplay)
	COM_INTERFACE_ENTRY(ISampleDisplay)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CSampleDisplay)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("BackColor", DISPID_BACKCOLOR, CLSID_StockColorPage)
	PROP_ENTRY("ForeColor", DISPID_FORECOLOR, CLSID_StockColorPage)
	PROP_ENTRY("Text", DISPID_TEXT, CLSID_NULL)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CSampleDisplay)
	CHAIN_MSG_MAP(CComControl<CSampleDisplay>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// ISampleDisplay: Generated (almost) entirely from the ATL object wizard (full control) 
public:

  STDMETHOD(FinalConstruct)( void )
  {
    m_bstrText = L"SampleDisplay";
    m_clrBackColor = RGB( 255, 255, 255 );
    m_clrForeColor = RGB( 0, 0, 0 );
    return S_OK;
  }

	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
    ::Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);
    ::SetTextAlign( di.hdcDraw, TA_CENTER|TA_BASELINE );
    ::SetBkColor( di.hdcDraw, m_clrBackColor );
    ::SetTextColor( di.hdcDraw, m_clrForeColor );
    ::TextOutW( di.hdcDraw, (rc.left + rc.right) / 2, (rc.top + rc.bottom) / 2, m_bstrText, m_bstrText.Length() );
		return S_OK;
	}

	OLE_COLOR m_clrBackColor;
	OLE_COLOR m_clrForeColor;
	CComBSTR m_bstrText;
};

#endif //__SAMPLEDISPLAY_H_
